-- Created by NuclearTonic
-- The use of this code requires the permission of the author.
-- Permission can be atained by contacting NuclearTonic at: TonicBars@gmail.com
--
-- RESPECT!

import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Tonic.Utils.Class";
import "Tonic.UI.CheckBox";
import "Tonic.UI.ComboBox";
import "Tonic.UI.AutoListBox";
import "Tonic.UI.MenuUtils";

buttonWidth = 85;
selectionWidth = 160;
selectionHeight = 20;
insideBoxXOffset = selectionWidth + 5;
insideBoxYOffset = startFromTop + 200;

GeneralMenu = class( Tonic.UI.AutoListBox );

function GeneralMenu:Constructor()
	Tonic.UI.AutoListBox.Constructor( self );

	self.utils = Tonic.UI.MenuUtils();
	
	if ( realClassSet == nil ) then
		self.utils:AddLabelBox( self, LOCALESTRINGS.GeneralMenu[1], selectionWidth + 200, selectionHeight + 10 );
		
		self.classList = Tonic.UI.ComboBox();
		self.classList:SetSize( 200, 20 );
		self.classList:SetParent( self );
		self.classList:AddItem( LOCALESTRINGS.ClassNames[1], 	23 );
		self.classList:AddItem( LOCALESTRINGS.ClassNames[2], 	24 );
		self.classList:AddItem( LOCALESTRINGS.ClassNames[3], 	31 );
		self.classList:AddItem( LOCALESTRINGS.ClassNames[4], 	40 );
		self.classList:AddItem( LOCALESTRINGS.ClassNames[5], 	162 );
		self.classList:AddItem( LOCALESTRINGS.ClassNames[6], 	172 );
		self.classList:AddItem( LOCALESTRINGS.ClassNames[7], 	185 );
		self.classList:AddItem( LOCALESTRINGS.ClassNames[8], 	193 );
		self.classList:AddItem( LOCALESTRINGS.ClassNames[9], 	194 );
		self:AddItem( self.classList );
	end
	
	self.utils:AddLabelBox( self, "If you want to copy your bar locations from another character on this server you can perform that by selecting the characters name from the dropdown and selecting 'Copy Profile'.", selectionWidth + 250, selectionHeight + 30 );
	
	self:AddSettings();
	self:AddCommandsBar();
	self:AddItem( self.settingsBox );
end

function GeneralMenu:AddSettings()
	self.settingsBox = self.utils:AddAutoListBox( self, Turbine.UI.Orientation.Vertical, 0, 0, 0, 0 );
	
	self.utils:AddLabelBox( self, LOCALESTRINGS.GeneralMenu[2], selectionWidth + 100, selectionHeight );

	self.profileList = Tonic.UI.ComboBox();
	self.profileList:SetSize( 200, 20 );
	self.profileList:SetParent( self );
	self:AddItem( self.profileList );
	
	self.utils:AddLabelBox( self, LOCALESTRINGS.GeneralMenu[3], selectionWidth + 100, selectionHeight );

	local box1 = self.utils:AddAutoListBox( self, Turbine.UI.Orientation.Horizontal );	
	local noShortcutButton = Turbine.UI.Lotro.Button();
	noShortcutButton:SetText( LOCALESTRINGS.GeneralMenu[4] );
	noShortcutButton:SetSize( buttonWidth + 75, selectionHeight );
	noShortcutButton.MouseClick = function( sender, args )
		local profile = self.profileList:GetSelection();
		if ( profile ~= nil ) then
			theSettingsManager:CopyProfile( profile, theSettingsManager.PARTIAL );
		end
	end
	box1:AddItem( noShortcutButton );

	local shortcutButton = Turbine.UI.Lotro.Button();
	shortcutButton:SetText( LOCALESTRINGS.GeneralMenu[5] );
	shortcutButton:SetSize( buttonWidth + 75, selectionHeight );
	shortcutButton.MouseClick = function( sender, args )
		local profile = self.profileList:GetSelection();
		if ( profile ~= nil ) then
			theSettingsManager:CopyProfile( profile, theSettingsManager.ALL );
		end
	end
	box1:AddItem( shortcutButton );
	self:AddItem( box1 );
	
	self.utils:AddLabelBox( self, LOCALESTRINGS.GeneralMenu[6], selectionWidth + 300, selectionHeight );
	self.displayGobletCheckbox = self.utils:AddCheckBox( self, LOCALESTRINGS.GeneralMenu[7], selectionWidth + 500, selectionHeight + 50 );
end

function GeneralMenu:AddCommandsBar()
end

function GeneralMenu:DisplaySettings( showQuickslots )
	self.settingsBox:SetVisible( showQuickslots );
	
	local theSettings = theSettingsManager:GetWrapperSettings();
	
	self.displayGobletCheckbox.CheckedCallback = function( sender, args )
		local settings = theSettingsManager:GetWrapperSettings();
		settings.visible = self.displayGobletCheckbox.IsChecked;
		theSettingsManager:SetWrapperSettings( settings );
	end
	self.displayGobletCheckbox:SetChecked( theSettings.visible );
	
	if ( realClassSet == nil ) then
		self.classList.SelectedIndexChanged = function(sender, args)
			local settings = theSettingsManager:GetSettings();
			if ( settings.playerClass ~= self.classList:GetSelection() ) then
				settings.playerClass = self.classList:GetSelection();
				playerClass = self.classList:GetSelection();
				theSettingsManager:SaveSettings();
				menu:RegenerateQuickslotsMenu();
				--menu = Tonic.TonicBars.Menu.MainMenu( theSettingsManager, maitre_d );
			end
		end
		theSettings = theSettingsManager:GetSettings();
		self.classList:SetSelection( theSettings.playerClass );
	end
end

function GeneralMenu:GetSelection()
	return nil;
end

function GeneralMenu:RefreshComboBox()
	self.profileList:Clear();
	for key, value in pairs (theSettingsManager:GetProfiles() ) do
		local found = false;
		if ( player:GetName() == key ) then
			found = true;
		end
		for i = 1, self.profileList:GetItemCount() do
			if ( self.profileList:GetItem(i) == key ) then
				found = true;
			end
		end
		if ( found == false ) then
			self.profileList:AddItem( key, key );
		end
	end
end