-- Created by NuclearTonic
-- If reusing this code, please keep the name of the original author listed
-- in respect for borrowing said authors code.
-- RESPECT!

import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Tonic.Utils.Class";
import "Tonic.UI.CheckBox";
import "Tonic.UI.ComboBox";
import "Tonic.UI.AutoListBox";

MenuUtils = class( Turbine.Object );

local bgColor = Turbine.UI.Color(1,0.0,0.0,0.0);

function MenuUtils:Constructor()
end

function MenuUtils:AddAutoListBox( parentBox, orientation, x, y, top, left, thebgcolor )
	local box;
	if ( x ~= nil ) then
		box = Tonic.UI.AutoListBox(x, y);
		box:SetPosition(top,left);
	else
		box = Tonic.UI.AutoListBox();
	end
	box:SetParent( parentBox );
	box:SetOrientation( orientation );
	if ( thebgcolor == nil ) then
		box:SetBackColor( bgColor );
	else
		box:SetBackColor( thebgcolor );
	end
	return box;
end

function MenuUtils:AddTextBox( parentBox, text, x, y, thebgcolor )
	local tb = Turbine.UI.Lotro.TextBox();
	tb:SetParent( parentBox );
	tb:SetText( text );
	tb:SetFont( 1 );
	tb:SetBackColor( unselectedColor );
	tb:SetTextAlignment( Turbine.UI.ContentAlignment.BottomLeft );
	tb:SetSize( x, y );
	if ( thebgcolor == nil ) then
		tb:SetBackColor( bgColor );
	else
		tb:SetBackColor( thebgcolor );
	end
	parentBox:AddItem( tb );
	return tb;
end

function MenuUtils:AddLabelBox( parentBox, text, x, y, thebgcolor )
	local lb = Turbine.UI.Label();
	lb:SetParent( parentBox );
	lb:SetText( text );
	lb:SetBackColor( unselectedColor );
	lb:SetTextAlignment( Turbine.UI.ContentAlignment.BottomLeft );
	lb:SetSize( x, y );
	if ( thebgcolor == nil ) then
		lb:SetBackColor( bgColor );
	else
		lb:SetBackColor( thebgcolor );
	end
	parentBox:AddItem( lb );
	return lb;
end

function MenuUtils:AddCheckBox( parentBox, text, x, y, thebgcolor )
	local cb = Tonic.UI.CheckBox();
	cb:SetParent( parentBox );
	cb:SetText( text );
	cb:SetBackColor( unselectedColor );
	cb:SetSize( x, y );
	if ( thebgcolor == nil ) then
		cb:SetBackColor( bgColor );
	else
		cb:SetBackColor( thebgcolor );
	end
	parentBox:AddItem( cb );
	return cb;
end

function MenuUtils:AddScrollBar( parentBox, value, minVal, maxVal, x, y, thebgcolor )
	local sb = Turbine.UI.Lotro.ScrollBar();
	sb:SetParent( parentBox );
	sb:SetSize( x, y );
	sb:SetValue( value );
	sb:SetMinimum( minVal );
	sb:SetMaximum( maxVal );
	sb:SetSmallChange( 1 );
	sb:SetLargeChange( 1 );
	if ( thebgcolor == nil ) then
		sb:SetBackColor( bgColor );
	else
		sb:SetBackColor( thebgcolor );
	end
	parentBox:AddItem( sb );
	return sb;
end